"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ansiStyle = require("ansi-styles");
const escapeStringRegexp = require("escape-string-regexp");
function links2md(str) {
    str = str.replace(/((http|https):\/\/(\w+:{0,1}\w*@)?([^\s\*\)`]+)(\/|\/([\w#!:.?+=&%@!\-\/]))?)/g, '[$1]($1)');
    str = str.replace(/\[(\d+)\]/g, '\\\[$1\\\]');
    return str;
}
exports.links2md = links2md;
function ansi2md(str) {
    str = str.replace(/</g, '&lt;').replace(/>/g, '&gt;');
    str = convertAnsiToMd(str, ansiStyle.green, { open: '`', close: '`' });
    str = convertAnsiToMd(str, ansiStyle.yellow, { open: '', close: '' });
    str = convertAnsiToMd(str, ansiStyle.bold, { open: '**', close: '**' });
    return str;
}
exports.ansi2md = ansi2md;
function convertAnsiToMd(str, style, md) {
    str = str.replace(new RegExp(escapeStringRegexp(style.open) + '(.*?)' + escapeStringRegexp(style.close), 'g'), md.open + '$1' + md.close);
    return str;
}
